#define APPNAME		"Qsniffer v0.3"
#define APPDESC		"A Under Developing Simple Eathernet Sniffer"
#define APPCOPYRIGHT	"Copyright (c) 2008 Qnix <qnix69[at]gmail[dot]org>"
#define APPDISCLAIMER	"THERE IS ABSOLUTELY NO WARRANTY FOR THIS PROGRAM."


#include <stdio.h>
#include <pcap.h>
#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <string.h>
#include <signal.h>

#include "ip.h"
#include "ethernet.h"
#include "tcp.h"

/* Error Return Number */
#define	ERROR		-1
/* Default Snap Length (Maximum Bytes Per Packet To Capture) */
#define	SNAP_LEN	1518
/* Ethernet Headers Are Always Exactly 14 Bytes */
#define	SIZE_ETHERNET	14
/* Ethernet Addresses Are 6 Bytes */
#define	ETHER_ADDR_LEN 6

FILE *file;			// File
char *filename;			// FileName
int output = 0;			// Output Data To A File (0=Disable,0!=Enable)
int printtype = 0;		// 0 = OFFSET/HEX/ASCII -- 1= OFFSET/ASCII

/* Prototypes */
void
got_packet (u_char * args, const struct pcap_pkthdr *header,
	    const u_char * packet);
void print_payload (const u_char * payload, int len);
void print_hex_ascii_line (const u_char * payload, int len, int offset);
void print_ascii_line (const u_char * payload, int len, int offset);
void print_app_banner (void);
void print_app_usage (void);
void help (char *appname);

enum boole
{
  FALSE,
  TRUE
};


/*
 * AppName/Banner
 * */
void
print_app_banner (void)
{
  fprintf (stdout,
	   "************************************************************\n");
  fprintf (stdout, "%s - %s\n", APPNAME, APPDESC);
  fprintf (stdout, "%s\n", APPCOPYRIGHT);
  fprintf (stdout, "%s\n", APPDISCLAIMER);
  fprintf (stdout,
	   "************************************************************\n\n");
  return;
}


/*
 * Help
 **/
void
help (char *appname)
{
  fprintf (stdout, "\nUsage : %s\t-i <Interface>\t\t: Select A Device\n"
	   "\t\t\t-f <Filter-Expression>\t: Select A Filter (Ex. tcp , ip , \"tcp port 80\"..etc) [Default: All]\n"
	   "\t\t\t-n <Number-Of-Packets>\t: Select The Number Of Packets To Capture [Default: All]\n"
	   "\t\t\t-o <Output-Filename>\t: Select a FileName For Output\n"
	   "\t\t\t-t <output-type>\t: 0 = [OFFSET/HEX/ASCII]\n"
	   "\t\t\t\t\t\t: 1 = [OFFSET/ASCII]\n"
	   "\t\t\t-p\t\t\t: Disable promisc mode [Default: enable]\n"
	   "\t\t\t-v\t\t\t: Qsniffer Version\n"
	   "\t\t\t-h\t\t\t: Help\n\n", appname);
  exit (EXIT_FAILURE);
}



/*
 * Print Data In Ascii
 */
void
print_ascii_line(const u_char * payload, int len, int offset)
{
	int i;
	int gap;
	const u_char *ch;

	/* Offset */
	fprintf(stdout,"%05d\t", offset);

	/* Ascii */
	ch = payload;
	
	for (i = 0; i < len; i++)
	{
		if (isprint (*ch))
			fprintf (stdout, "%c", *ch);
		else
			fprintf (stdout, ".");
		ch++;
	}
	
	fprintf (stdout, "\n");
	
	return;

	

}

/*
 * Print Data In Rows Of 16 Bytes: Offset   Hex   Ascii
 * 00000   47 45 54 20 2f 20 48 54  54 50 2f 31 2e 31 0d 0a   GET / HTTP/1.1..
 *
 */
void
print_hex_ascii_line (const u_char * payload, int len, int offset)
{

  int i;
  int gap;
  const u_char *ch;


  /* Offset */
  fprintf (stdout, "%05d", offset);
  if (output == 1)
    fprintf (file, "%05d", offset);

  /* Hex */
  ch = payload;
  for (i = 0; i < len; i++)
    {
      fprintf (stdout, "%02x ", *ch);
      if (output == 1)
	fprintf (file, "%02x", *ch);
      ch++;
      /* Print Extra Space After 8th Byte For Visual Aid */
      if (i == 7)
	{
	  fprintf (stdout, " ");
	  if (output == 1)
	    fprintf (file, " ");
	}
    }
  /* Print Space To Handle Line Less Than 8 Bytes */
  if (len < 8)
    {
      fprintf (stdout, " ");
      if (output == 1)
	fprintf (file, " ");
    }
  /* Fill Hex Gap With Spaces If Not Full Line */
  if (len < 16)
    {
      gap = 16 - len;
      for (i = 0; i < gap; i++)
	{
	  fprintf (stdout, "   ");
	  if (output == 1)
	    fprintf (file, "   ");
	}
    }
  fprintf (stdout, "   ");
  if (output == 1)
    fprintf (file, "   ");

  /* Ascii (If Printable) */
  ch = payload;
  for (i = 0; i < len; i++)
    {
      if (isprint (*ch))
	{
	  fprintf (stdout, "%c", *ch);
	  if (output == 1)
	    fprintf (file, "%c", *ch);
	}
      else
	{
	  fprintf (stdout, ".");
	  if (output == 1)
	    fprintf (file, ".");
	}
      ch++;
    }

  fprintf (stdout, "\n");
  if (output == 1)
    fprintf (file, "\n");

  return;
}


/*
 * Print Packet Payload Data (Avoid Printing Binary Data)
 */
void
print_payload (const u_char * payload, int len)
{

  int len_rem = len;
  int line_width = 16;		/* Number Of Bytes Per Line */
  int line_len;
  int offset = 0;		/* Zero-Based Offset Counter */
  const u_char *ch = payload;

  if (len <= 0)
    return;

  /* Data Fits On One Line if print type OFFSET/HEX/ASCII */
if(printtype == 0) {
  if (len <= line_width)
    {
      print_hex_ascii_line (ch, len, offset);
      return;
    }
}

  /* Data Spans Multiple Lines */
  for (;;)
    {
      /* Compute Current Line Length */
      line_len = line_width % len_rem;
      /* Print Line */
	if(printtype == 0)
		print_hex_ascii_line (ch, line_len, offset);
	else
		print_ascii_line (ch,line_len,offset);

      /* Compute Total Remaining */
      len_rem = len_rem - line_len;
      /* Shift Pointer To Remaining Bytes To Print */
      ch = ch + line_len;
      /* Add Offset */
      offset = offset + line_width;
      /* Check If We Have Line Width Chars Or Less */
	if(printtype == 0) {
      		if (len_rem <= line_width)
		{
	  	/* Print Last Line And Get Out */
	  	print_hex_ascii_line (ch, len_rem, offset);
	  	break;
		}
	} else if(printtype == 1) {
		if(len_rem <= line_width) {
			print_ascii_line(ch, len_rem, offset);
			break;
		}
	}
    }

  return;
}

/*
 * Dissect/Print Packet
 */
void
got_packet (u_char * args, const struct pcap_pkthdr *header,
	    const u_char * packet)
{

  static int count = 1;		/* Packet Counter */

  /* Declare Pointers To Packet Headers */
  const struct sniff_ethernet *ethernet;	/* The Ethernet Header */
  const struct sniff_ip *ip;	/* The IP Header */
  const struct sniff_tcp *tcp;	/* The TCP Header */
  const char *payload;		/* Packet Payload */

  int size_ip;
  int size_tcp;
  int size_payload;

  fprintf (stdout, "\nPacket Number %d:\n", count);
  if (output == 1)
    fprintf (file, "\nPacket Number %d:\n", count);
  count++;

  /* Define Ethernet Header */
  ethernet = (struct sniff_ethernet *) (packet);

  /* Define/Compute Ip Header Offset */
  ip = (struct sniff_ip *) (packet + SIZE_ETHERNET);
  size_ip = IP_HL (ip) * 4;
  if (size_ip < 20)
    {
      fprintf (stdout, "   * Invalid IP Header Length: %u Bytes\n", size_ip);
      if (output == 1)
	fprintf (file, "   * Invalid IP Header Length: %u Bytes\n", size_ip);
      return;
    }

  /* Print Source And Destination IP Addresses */
  fprintf (stdout, "       From: %s\n", inet_ntoa (ip->ip_src));
  if (output == 1)
    fprintf (file, "       From: %s\n", inet_ntoa (ip->ip_src));
  fprintf (stdout, "         To: %s\n", inet_ntoa (ip->ip_dst));
  if (output == 1)
    fprintf (file, "       To:%s\n", inet_ntoa (ip->ip_dst));

  /* Determine Protocol */
  switch (ip->ip_p)
    {
    case IPPROTO_TCP:
      fprintf (stdout, "   Protocol: TCP\n");
      if (output == 1)
	fprintf (file, "   Protocol: TCP\n");
      break;
    case IPPROTO_UDP:
      fprintf (stdout, "   Protocol: UDP\n");
      if (output == 1)
	fprintf (file, "   Protocol: UDP\n");
      return;
    case IPPROTO_ICMP:
      fprintf (stdout, "   Protocol: ICMP\n");
      if (output == 1)
	fprintf (file, "   Protocol: ICMP\n");
      return;
    case IPPROTO_IP:
      fprintf (stdout, "   Protocol: IP\n");
      if (output == 1)
	fprintf (file, "   Protocol: IP\n");
      return;
    default:
      fprintf (stdout, "   Protocol: Unknown\n");
      if (output == 1)
	fprintf (file, "   Protocol: Unknown\n");
      return;
    }

  /*
   *  OK, This Packet Is TCP.
   */

  /* Define/Compute Tcp Header Offset */
  tcp = (struct sniff_tcp *) (packet + SIZE_ETHERNET + size_ip);
  size_tcp = TH_OFF (tcp) * 4;
  if (size_tcp < 20)
    {
      fprintf (stdout, "   * Invalid TCP Header Length: %u Bytes\n",
	       size_tcp);
      if (output == 1)
	fprintf (file, "   * Invalid TCP Header Length: %u Bytes\n",
		 size_tcp);
      return;
    }

  fprintf (stdout, "   Src Port: %d\n", ntohs (tcp->th_sport));
  if (output == 1)
    fprintf (file, "   Src Port: %d\n", ntohs (tcp->th_sport));
  fprintf (stdout, "   Dst Port: %d\n", ntohs (tcp->th_dport));
  if (output == 1)
    fprintf (file, "   Dst Port: %d\n", ntohs (tcp->th_dport));

  /* Define/Compute Tcp Payload (Segment) Offset */
  payload = (u_char *) (packet + SIZE_ETHERNET + size_ip + size_tcp);

  /* Compute Tcp Payload (Segment) Size */
  size_payload = ntohs (ip->ip_len) - (size_ip + size_tcp);

  /*
   * Print Payload Data; It Might Be Binary, So Don't Just
   * Treat It As a String.
   */
  if (size_payload > 0)
    {
      fprintf (stdout, "   Payload (%d Bytes):\n", size_payload);
      if (output == 1)
	fprintf (file, "   Payload (%d Bytes):\n", size_payload);
      print_payload (payload, size_payload);
    }

  return;
}



void
termination_handler (int signum)
{
  fprintf (stderr, "\n*** Qsniffer Interrupted ***\n");
  if (output == 1)
    {
      fprintf (stderr, "*** Saving %s ***\n", filename);
      fclose (file);
    }
  fprintf (stderr, "*** EXITING... ***\n");
  exit (EXIT_FAILURE);
}

int
main (int argc, char **argv)
{

  char *device = NULL;		// Device Name
  char *nets;			// Dot Notation Of The Network Address
  char *masks;			// Dot Notation Of The Network Mask
  char errbuf[PCAP_ERRBUF_SIZE];	// Error Buffer
  char *filter_exp = NULL;	// Filter Expression
  pcap_t *handle;		// Packet Capture Handle
  struct bpf_program fp;	// Compiled Filter Programe
  bpf_u_int32 mask;		// Subnet Mask
  bpf_u_int32 net;		// Ip
  struct in_addr addr;
  int num_packets = 0;		// Number Of Packets To Capture
  int c;			// Options Of Getopt
  int promisc = 0;		// Promisc mode (enable=0/disable=1)
  opterr = 0;			// Getopt Error

  print_app_banner ();		// Print Application Banner




  // SIGNALS HANDLING
  if (signal (SIGINT, termination_handler) == SIG_IGN)
    signal (SIGINT, SIG_IGN);
  if (signal (SIGHUP, termination_handler) == SIG_IGN)
    signal (SIGHUP, SIG_IGN);
  if (signal (SIGTERM, termination_handler) == SIG_IGN)
    signal (SIGTERM, SIG_IGN);


  // Getting Options
  while ((c = getopt (argc, argv, "o:t:n:i:f:hpv")) != -1)
    {
      switch (c)
	{
	case 'i':		// Interface
	  device = optarg;
	  break;
	case 'h':		// help();
	  help (argv[0]);
	  break;
	case 'v':		// view print_app_banner();
	  exit (EXIT_SUCCESS);
	  break;
	case 'p':		// Disable Promisc mode
	  promisc = 1;
	  break;
	case 't':
	  printtype = atoi(optarg);
	  break;
	case 'f':		// Filter Expression
	  filter_exp = optarg;
	  break;
	case 'n':		// Number Of Packets To Capture
	  num_packets = atoi (optarg);
	  break;
	case 'o':		// Log Output To A File
	  output = 1;		// Enable Output
	  filename = optarg;	// Set FileName
	  break;
	case '?':
	  if(optopt == 't') {
	  	fprintf(stderr,"Option -%c Requires An Argument.\n", optopt);
		help(argv[0]);
	  }
	  else if (optopt == 'i')
	    {
	      fprintf (stderr, "Option -%c Requires An Argument.\n", optopt);
	      help (argv[0]);
	    }
	  else if (optopt == 'f')
	    {
	      fprintf (stderr, "Option -%c Requires A Filter Expression.\n",
		       optopt);
	      help (argv[0]);
	    }
	  else if (optopt == 'n')
	    {
	      fprintf (stderr,
		       "Option -%c Requires A Packets Number To Capture.\n",
		       optopt);
	      help (argv[0]);
	    }
	  else if (optopt == 'o')
	    {
	      fprintf (stderr, "Option -%c Requires A File Name.\n", optopt);
	      help (argv[0]);
	    }
	  else if (isprint (optopt))
	    {
	      fprintf (stderr, "Unknown Option `-%c'.\n", optopt);
	      help (argv[0]);
	    }
	  else
	    {
	      fprintf (stderr, "Unknown Option Character `\\x%x'.\n", optopt);
	      help (argv[0]);
	    }
	}
    }


  /* Check if Print Type is Available*/
  if(printtype > 1) {
	  fprintf(stderr,"The printing type you selected is not available\n");
	  help(argv[0]);
	  exit(EXIT_FAILURE);
  }

  /* Select Device Automatically or Manually */
  if (device == NULL)
    {
      device = pcap_lookupdev (errbuf);
      fprintf (stdout, "For Help Type \"%s -h\"\n\n", argv[0]);
      fprintf (stdout, "[*Device Detection : Auto*]\n");
    }
  else
    {
      fprintf (stdout, "[*Device Detection : Manual*]\n");
    }


  /* Get Network Number And Mask Associated With Capture Device */
  if (pcap_lookupnet (device, &net, &mask, errbuf) == -1)
    {
      fprintf (stderr, "Couldn't Get Netmask For Device %s\n", errbuf);
      net = 0;
      mask = 0;
      exit (EXIT_FAILURE);
    }
  else
    {

      addr.s_addr = net;
      nets = inet_ntoa (addr);

      if (nets == NULL)
	{
	  perror ("inet_ntoa");
	  exit (EXIT_FAILURE);
	}

      fprintf (stdout, "Net : %s\n", nets);

      addr.s_addr = mask;
      masks = inet_ntoa (addr);

      if (masks == NULL)
	{
	  perror ("inet_ntoa");
	  exit (EXIT_FAILURE);
	}

      fprintf (stdout, "Mask : %s\n", masks);
    }

  /* Print FileName */
  if (output == 1)
    {
      fprintf (stdout, "Output FileName : %s\n", filename);
    }

  /* Print Out Info */
  fprintf (stdout, "Device : %s\n", device);
  if (num_packets == 0)
    fprintf (stdout, "Number of Packets : all\n");
  else
    fprintf (stdout, "Number Of Packets : %d\n", num_packets);
  if (filter_exp == 0)
    fprintf (stdout, "Filter Expression : all\n");
  else
    fprintf (stdout, "Filter Expression : %s\n", filter_exp);
  if (promisc == 1)
    fprintf (stdout, "Promisc mode : False\n");
  else
    fprintf (stdout, "Promisc mode : True\n");
  if(printtype == 0)
	  fprintf(stdout,"Print Type : All (offset,hex,asii)");
  else if(printtype == 1)
	  fprintf(stdout,"Print Type : Ascii (offset,acsii)");


  /* Open Capture Device in Default mode or Promisc mode */
  if (promisc == 1)
    {
      handle = pcap_open_live (device, SNAP_LEN, FALSE, 1000, errbuf);
      if (handle == NULL)
	{
	  fprintf (stderr, "Couldn't Open Device %s", errbuf);
	  exit (EXIT_FAILURE);
	}
    }
  else
    {
      handle = pcap_open_live (device, SNAP_LEN, TRUE, 1000, errbuf);
      if (handle == NULL)
	{
	  fprintf (stderr, "Couldn't Open Device %s in Promisc mode\n",
		   errbuf);
	  exit (EXIT_FAILURE);
	}
    }

  /* Make Sure We're Capturing On An Ethernet Device */
  if (pcap_datalink (handle) != DLT_EN10MB)
    {
      fprintf (stderr, "%s Is Not An Ethernet\n", device);
      exit (EXIT_FAILURE);
    }

  /* Compile The Filter Expression */
  if (pcap_compile (handle, &fp, filter_exp, FALSE, net) == -1)
    {
      fprintf (stderr, "Couldn't Parse Filter %s:%s\n", filter_exp,
	       pcap_geterr (handle));
      exit (EXIT_FAILURE);
    }

  /* Apply The Compiled Filter */
  if (pcap_setfilter (handle, &fp) == -1)
    {
      fprintf (stderr, "Couldn't Install Filter %s:%s\n", filter_exp,
	       pcap_geterr (handle));
      exit (EXIT_FAILURE);
    }

  /* Output Data To File */
  if (output == 1)
    {
      file = fopen (filename, "w+");	// open file
      if (file == NULL)
	{
	  fprintf (stderr, "Couldn't Write On %s\n", filename);
	  output = 0;		// Disable
	}
      else
	{
	  fprintf (file, "*** This File Created By %s ***\n\n", APPNAME);
	}
    }

  /* Set Our Callback Function */
  if (num_packets != 0)
    {
      // Specified number of packets to sniff
      pcap_loop (handle, num_packets, got_packet, NULL);
    }
  else
    {
      // Unspecified number of packets to sniff
      pcap_loop (handle, -1, got_packet, NULL);
    }

  /* Cleanup Pcap */
  pcap_freecode (&fp);
  pcap_close (handle);

  /* If File Open Then fclose() */
  if (output == 1)
    fclose (file);

  fprintf (stdout, "\n[*Capture Complete*]\n");

  return 0;
}
